diff -r -u -H -N gcc-2.6.3/loop.c gcc-i2.6.3/loop.c
--- gcc-2.6.3/loop.c	Wed Nov 16 19:29:26 1994
+++ gcc-i2.6.3/loop.c	Thu Feb 16 12:59:32 1995
@@ -38,6 +38,7 @@
 #include "rtl.h"
 #include "obstack.h"
 #include "expr.h"
+#include "basic-block.h" /* intel1 */
 #include "insn-config.h"
 #include "insn-flags.h"
 #include "regs.h"
@@ -45,6 +46,7 @@
 #include "recog.h"
 #include "flags.h"
 #include "real.h"
+#include "reload.h" /* intel1 */
 #include "loop.h"
 
 /* Vector mapping INSN_UIDs to luids.
@@ -185,6 +187,9 @@
 
 static struct obstack temp_obstack;
 
+/* intel1 */
+extern struct obstack momentary_obstack;
+
 /* This is where the pointer to the obstack being used for RTL is stored.  */
 
 extern struct obstack *rtl_obstack;
@@ -280,6 +285,64 @@
 static int last_use_this_basic_block ();
 static void record_initial ();
 static void update_reg_last_use ();
+/* intel1 */
+static int compare_elimination ();
+static attempt_new_rtx ();
+static rtx make_new_use ();
+static int possible_compare_elimination ();
+static void find_regs_mentioned ();
+static void use_regs_source ();
+static rtx replace_mems ();
+static void replace_reg  ();
+static int two_to_power ();
+static int jumps_back_in_loop ();
+static loop_copy_propogate ();
+static do_replace ();
+static rtx subst_cands ();
+static try_unroll_propogation ();
+static rtx unroll_subst_cands ();
+static unroll_consistancy_maintained ();
+static int do_reduce_index ();
+static loop_spl ();
+void loop_after_global ();
+static int spill_invariant_p ();
+static void move_spills_out ();
+static void move_spill_movables ();
+static rtx subst_stack_slot ();
+static int check_if_jumps_out_of_loop ();
+static void mark_regs_alive_at_exit ();
+static void verify_spill_candidates ();
+static void mark_spill_candidates ();
+static void spill_handle_regs_mentioned ();
+static int is_updated_by_const ();
+static int is_updated_by_const_or_reg ();
+static void peep_init_info ();
+static void spill_peep_insn ();
+void update_stack_offset ();
+static void replace_spill_slots ();
+static rtx replace_linked_regs ();
+static void mark_regs_live_outside ();
+static void mark_regs_mentioned ();
+static int loop_contains_loop ();
+static void push_load_into_loop ();
+static int spill_slot_unused_between ();
+static int spill_slot_mentioned ();
+void init_undo_buf ();
+void subst_in_insn ();
+static void inner_subst_in_insn ();
+void loop_undo_all ();
+static void update_last_reloads ();
+static void sign_extension_reduction ();
+static void validate_all_references ();
+static void lift_stores ();
+static void mark_mem_refs ();
+static void insert_mem_ref ();
+static void opt_reg_use_copy ();
+int doing_spl = 0;
+int doing_loop_after_global = 0;
+static char * reg_live_outside_loop;
+static int cur_stack_offset = 0;
+
 
 /* Relative gain of eliminating various kinds of operations.  */
 int add_cost;
@@ -287,6 +350,10 @@
 int shift_cost;
 int mult_cost;
 #endif
+/* intel1 maximum # of insns in loop for which compare elimination */
+#ifndef MAX_CMP_ELIM
+#define MAX_CMP_ELIM 100
+#endif
 
 /* Benefit penalty, if a giv is not replaceable, i.e. must emit an insn to
    copy the value of the strength reduced giv to its original register.  */
@@ -335,6 +402,12 @@
 
   max_reg_before_loop = max_reg_num ();
 
+  /* intel1 */
+#ifdef SAVE_ON_REGS
+  if (!flag_all_mem_givs && flag_opt_reg_use)
+    reg_live_outside_loop = (char *) alloca(max_reg_before_loop);
+#endif
+
   moved_once = (char *) alloca (max_reg_before_loop);
   bzero (moved_once, max_reg_before_loop);
 
@@ -352,7 +425,17 @@
 
   /* Don't waste time if no loops.  */
   if (max_loop_num == 0)
-    return;
+    {
+      /* intel1 */
+#ifdef SAVE_ON_REGS
+      if (!doing_loop_after_global && flag_opt_reg_use)
+        {
+          use_regs_source (f, NULL, 0);
+          opt_reg_use_copy (f);
+        }
+#endif
+      return;
+    }
 
   /* Get size to use for tables indexed by uids.
      Leave some space for labels allocated by find_and_verify_loops.  */
@@ -379,7 +462,8 @@
   /* Now find all register lifetimes.  This must be done after
      find_and_verify_loops, because it might reorder the insns in the
      function.  */
-  reg_scan (f, max_reg_num (), 1);
+  /* intel1  Last paramater of reg_scan used to be 1.  */
+  reg_scan (f, max_reg_num (), !doing_loop_after_global);
 
   /* See if we went too far.  */
   if (get_max_uid () > max_uid_for_loop)
@@ -430,6 +514,43 @@
       scan_loop (loop_number_loop_starts[i], loop_number_loop_ends[i],
 		 max_reg_num ());
 
+  /* intel1 */
+  if (flag_strength_reduce && flag_copy_prop)
+    {  
+      for (i = max_loop_num-1; i >= 0; i--)
+        {
+          if (! loop_invalid[i] && loop_number_loop_ends[i])
+            loop_copy_propogate (loop_number_loop_starts[i], loop_number_loop_ends[i]);
+        }
+    }
+  /* intel1 */
+  if ((flag_lift_stores || flag_runtime_lift_stores) 
+      && !doing_loop_after_global)
+    {  
+      for (i = max_loop_num-1; i >= 0; i--)
+        {
+          if (! loop_invalid[i] && loop_number_loop_ends[i])
+               lift_stores (loop_number_loop_starts[i], loop_number_loop_ends[i]);
+        }
+    }
+
+#ifdef SAVE_ON_REGS
+  if (!doing_loop_after_global && flag_opt_reg_use)
+    {
+      use_regs_source (f, NULL, 0); 
+      opt_reg_use_copy (f);
+    }
+#endif
+  /* intel1 */
+#ifdef STORE_NOT_SET_CC0
+#ifdef STACK_REGS
+  if (flag_sftwr_pipe && !doing_loop_after_global)
+      for (i = max_loop_num-1; i >= 0; i--)
+        {
+          loop_spl (loop_number_loop_starts[i], loop_number_loop_ends[i], i, 0);
+        }
+#endif
+#endif
   /* If debugging and unrolling loops, we must replicate the tree nodes
      corresponding to the blocks inside the loop, so that the original one
      to one mapping will remain.  */
@@ -486,9 +607,29 @@
      if it was used exactly once; contains const0_rtx if it was used more
      than once.  */
   rtx *reg_single_usage = 0;
+  
   /* Nonzero if we are scanning instructions in a sub-loop.  */
   int loop_depth = 0;
 
+  /* intel1 */
+  if (doing_loop_after_global
+     && !(GET_CODE (PREV_INSN (end)) == JUMP_INSN
+     &&   GET_CODE (NEXT_INSN (loop_start)) == CODE_LABEL
+     &&   JUMP_LABEL (PREV_INSN (end)) == NEXT_INSN (loop_start)
+      )
+    )
+  {
+    return;
+  }
+#ifdef SAVE_ON_REGS
+  if (!flag_all_mem_givs && !doing_loop_after_global
+     && !loop_contains_loop (loop_start, end) && flag_opt_reg_use)
+    {
+      bzero (reg_live_outside_loop, max_reg_before_loop);
+      mark_regs_live_outside (loop_start, end);
+    }
+#endif
+
   n_times_set = (short *) alloca (nregs * sizeof (short));
   n_times_used = (short *) alloca (nregs * sizeof (short));
   may_not_optimize = (char *) alloca (nregs);
@@ -584,7 +725,8 @@
 
   count_loop_regs_set (loop_top ? loop_top : loop_start, end,
 		       may_not_optimize, reg_single_usage, &insn_count, nregs);
-
+  /* intel1 added if but not body */
+  if (!doing_loop_after_global)
   for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
     may_not_optimize[i] = 1, n_times_set[i] = 1;
   bcopy ((char *) n_times_set, (char *) n_times_used, nregs * sizeof (short));
@@ -637,6 +779,8 @@
 	in_libcall = 0;
 
       if (GET_CODE (p) == INSN
+          /* intel1 */
+      && (!doing_loop_after_global || GET_CODE(PATTERN(p)) == SET)
 	  && (set = single_set (p))
 	  && GET_CODE (SET_DEST (set)) == REG
 	  && ! may_not_optimize[REGNO (SET_DEST (set))])
@@ -688,11 +832,19 @@
 	  else if (! ((! maybe_never
 		       && ! loop_reg_used_before_p (set, p, loop_start,
 						    scan_start, end))
-		      || (! REG_USERVAR_P (SET_DEST (set))
-			  && ! REG_LOOP_TEST_P (SET_DEST (set)))
+		      ||  (!doing_loop_after_global 
+		           && /* intel1 */!REG_USERVAR_P (SET_DEST (set))
+		           && ! REG_LOOP_TEST_P (SET_DEST (set)))
 		      || reg_in_basic_block_p (p, SET_DEST (set))))
 	    ;
-	  else if ((tem = invariant_p (src))
+	  else if (((tem = invariant_p (src))
+	             /* intel1 */ || (doing_loop_after_global 
+	             && RTX_IS_SPILL_P (p) == 1 && spill_invariant_p (src))
+	           )
+	           /* intel1 */
+                    && !(doing_loop_after_global 
+	            && call_used_regs[REGNO (SET_DEST (set))]
+	            && loop_has_call)
 		   && (dependencies == 0
 		       || (tem2 = invariant_p (dependencies)) != 0)
 		   && (n_times_set[REGNO (SET_DEST (set))] == 1
@@ -742,6 +894,7 @@
 		     might span a call.  */
 		  && ! modified_between_p (SET_SRC (set), p,
 					   reg_single_usage[regno])
+          && !doing_loop_after_global /* intel1 */
 		  && no_labels_between_p (p, reg_single_usage[regno])
 		  && validate_replace_rtx (SET_DEST (set), SET_SRC (set),
 					   reg_single_usage[regno]))
@@ -957,12 +1110,25 @@
   move_movables (movables, threshold,
 		 insn_count, loop_start, end, nregs);
 
+  /* intel1 */
+  if (doing_loop_after_global && !loop_has_call)
+    {
+      move_spills_out(loop_start, end, nregs);
+    }
   /* Now candidates that still are negative are those not moved.
      Change n_times_set to indicate that those are not actually invariant.  */
   for (i = 0; i < nregs; i++)
     if (n_times_set[i] < 0)
       n_times_set[i] = n_times_used[i];
 
+  /*intel1 */
+#ifdef SAVE_ON_REGS
+   if (!doing_loop_after_global && flag_opt_reg_use)
+   {
+     use_regs_source(loop_start, end, 1); 
+   }
+#endif
+
   if (flag_strength_reduce)
     strength_reduce (scan_start, end, loop_top,
 		     insn_count, loop_start, end);
@@ -1248,7 +1414,7 @@
 	      /* A reg used for zero-extending mustn't be eliminated.  */
 	      && !m1->partial
 	      && (matched_regs[m1->regno]
-		  ||
+		  || 
 		  (
 		   /* Can combine regs with different modes loaded from the
 		      same constant only if the modes are the same or
@@ -1525,6 +1691,13 @@
      rtx end;
      int nregs;
 {
+/* intel1 */
+#ifdef SAVE_ON_REGS
+  rtx sinsn,last_sym;
+  int num_sym_adds;
+#endif
+  /* intel1 */
+  int *insns_deleted;
   rtx new_start = 0;
   register struct movable *m;
   register rtx p;
@@ -1539,6 +1712,46 @@
 
   num_movables = 0;
 
+  /* intel1 */
+  num_movables = 0;
+
+/* intel1 Any insn moved out of loop must be deleted from the log_links
+          of all other insns in the loop.
+*/
+  if (doing_loop_after_global)
+    {
+        insns_deleted = (int *) alloca ((max_uid_for_loop+1) * sizeof (int));
+        bzero(insns_deleted,(max_uid_for_loop+1) * sizeof (int));
+    }
+/* intel1 */
+#ifdef SAVE_ON_REGS
+  num_sym_adds=0;
+  last_sym = NULL;
+  for (sinsn=loop_start;flag_opt_reg_use && (sinsn!=end && num_sym_adds < 2);
+        sinsn=NEXT_INSN (sinsn))
+     {
+        if (GET_CODE (sinsn) == INSN
+           && GET_CODE (PATTERN (sinsn)) == SET
+           && GET_CODE (SET_DEST (PATTERN (sinsn))) == REG
+           && GET_CODE (SET_SRC (PATTERN (sinsn))) == PLUS
+           && GET_CODE (XEXP (SET_SRC (PATTERN (sinsn)), 0)) == REG
+           && GET_CODE (XEXP (SET_SRC (PATTERN (sinsn)), 1)) == SYMBOL_REF)
+      {
+        if (last_sym)
+      {
+        if (!rtx_equal_p (XEXP (SET_SRC (PATTERN (sinsn)), 1),
+                        last_sym))
+          {
+            num_sym_adds++;
+          }
+      }
+        else
+      {
+        last_sym = XEXP (SET_SRC (PATTERN (sinsn)), 1);
+      }
+      }
+    }
+#endif /* SAVE_ON_REGS */
   for (m = movables; m; m = m->next)
     {
       /* Describe this movable insn.  */
@@ -1617,7 +1830,30 @@
 
 	  /* It is also desirable to move if it can be moved at no
 	     extra cost because something else was already moved.  */
-
+#ifdef SAVE_ON_REGS
+  	  /* intel1 if the insn is regx <- regy + symbol_ref then don't move
+  	     if there is more than one.  
+  	  */
+  	  if (flag_opt_reg_use
+  	     && num_sym_adds > 1 
+  	     && GET_CODE (PATTERN (m->insn)) == SET 
+  	     && GET_CODE (SET_DEST (PATTERN (m->insn))) == REG 
+  	     && GET_CODE (SET_SRC (PATTERN (m->insn))) == PLUS 
+  	     && GET_CODE (XEXP (SET_SRC (PATTERN (m->insn)), 0)) == REG 
+  	     && GET_CODE (XEXP (SET_SRC (PATTERN (m->insn)), 1)) == SYMBOL_REF)
+	    {
+	      savings = 0;
+	    } 
+#endif  	     
+/* intel1 */
+#ifdef STACK_REGS
+#ifdef IS_STACK_MODE
+          if (IS_STACK_MODE (DFmode)
+             && GET_CODE (PATTERN (m->insn)) == SET 
+             && GET_CODE (SET_SRC (PATTERN (m->insn))) == CONST_DOUBLE)
+            savings = 0; /* not worthwhile */
+#endif
+#endif
 	  if (already_moved[regno]
 	      || (threshold * savings * m->lifetime) >= insn_count
 	      || (m->forces && m->forces->done
@@ -1650,11 +1886,24 @@
 		  regs_may_share = gen_rtx (EXPR_LIST, VOIDmode, r1,
 					    gen_rtx (EXPR_LIST, VOIDmode, r2,
 						     regs_may_share));
+                  /* intel1 */
+                  if (doing_loop_after_global 
+                     && INSN_UID (m->insn) <= max_uid_for_loop)
+                    {
+                      insns_deleted[INSN_UID (m->insn)] = 1;
+                    }
 		  delete_insn (m->insn);
 
 		  if (new_start == 0)
 		    new_start = i1;
 
+                  /* intel1 */
+                  if (doing_loop_after_global)
+                    {
+                      RTX_IS_SPILL_P (i1) = RTX_IS_SPILL_P (m->insn);
+                      SPILL_PSEUDO (i1) = SPILL_PSEUDO (m->insn);
+                    }
+                    
 		  if (loop_dump_stream)
 		    fprintf (loop_dump_stream, " moved to %d", INSN_UID (i1));
 		}
@@ -1681,8 +1930,22 @@
 			{
 			  temp = XEXP (temp, 0);
 			  while (temp != p)
-			    temp = delete_insn (temp);
+              {
+                  /* intel1 */
+                  if (doing_loop_after_global
+                      && INSN_UID( temp) <= max_uid_for_loop)
+                  {
+                       insns_deleted[INSN_UID( temp)] = 1;
+                  }
+                temp = delete_insn (temp);
+              }
 			}
+               /* intel1 */
+             if (doing_loop_after_global
+                && INSN_UID( p) <= max_uid_for_loop)
+             {
+                 insns_deleted[INSN_UID( p)] = 1;
+              }
 
 		      p = delete_insn (p);
 		      while (p && GET_CODE (p) == NOTE)
@@ -1703,6 +1966,13 @@
 				 m->is_equiv ? REG_EQUIV : REG_EQUAL,
 				 m->set_src, REG_NOTES (i1));
 
+                  /* intel1 */
+                  if (doing_loop_after_global)
+                    {
+                      RTX_IS_SPILL_P (i1) = RTX_IS_SPILL_P (m->insn);
+                      SPILL_PSEUDO (i1) = SPILL_PSEUDO (m->insn);
+                    }
+
 		  if (loop_dump_stream)
 		    fprintf (loop_dump_stream, " moved to %d", INSN_UID (i1));
 
@@ -1804,6 +2074,12 @@
 			      if (temp == fn_address_insn)
 				fn_address_insn = i1;
 			      REG_NOTES (i1) = REG_NOTES (temp);
+                              /* intel1 */
+                              if (doing_loop_after_global 
+                                 && INSN_UID (temp) <= max_uid_for_loop)
+                                {
+                                  insns_deleted[INSN_UID (temp)] = 1;
+                                }
 			      delete_insn (temp);
 			    }
 			}
@@ -1859,6 +2135,13 @@
 		      if (new_start == 0)
 			new_start = i1;
 
+                      /* intel1 */
+                      if (doing_loop_after_global)
+                        {
+                          RTX_IS_SPILL_P (i1) = RTX_IS_SPILL_P (m->insn);
+                          SPILL_PSEUDO (i1) = SPILL_PSEUDO (m->insn);
+                        }
+                        
 		      if (loop_dump_stream)
 			fprintf (loop_dump_stream, " moved to %d",
 				 INSN_UID (i1));
@@ -1886,6 +2169,12 @@
 			  XEXP (temp, 0) = i1;
 			}
 
+                      /* intel1 */
+                      if (doing_loop_after_global 
+                         && INSN_UID (p) <= max_uid_for_loop)
+                        {
+                          insns_deleted[INSN_UID (p)] = 1;
+                        }
 		      delete_insn (p);
 		      do p = NEXT_INSN (p);
 		      while (p && GET_CODE (p) == NOTE);
@@ -1950,8 +2239,22 @@
 			{
 			  for (temp = XEXP (temp, 0); temp != m1->insn;
 			       temp = NEXT_INSN (temp))
-			    delete_insn (temp);
+			    {
+                              /* intel1 */
+                              if (doing_loop_after_global 
+                                 && INSN_UID (temp) <= max_uid_for_loop)
+                                {
+                                  insns_deleted[INSN_UID (temp)] = 1;
+                                }
+			      delete_insn (temp);
+			    }
 			}
+                      /* intel1 */
+                      if (doing_loop_after_global 
+                         && INSN_UID (m1->insn) <= max_uid_for_loop)
+                        {
+                          insns_deleted[INSN_UID (m1->insn)] = 1;
+                        }
 		      delete_insn (m1->insn);
 
 		      /* Any other movable that loads the same register
@@ -1987,6 +2290,34 @@
 	replace_regs (REG_NOTES (p), reg_map, nregs, 0);
 	INSN_CODE (p) = -1;
       }
+  /* intel1 */
+  /* remove all deleted insns from the log_links of any insn in which
+     they appear */
+  if (doing_loop_after_global)
+    {
+        int i;
+        rtx rn,prev,link;
+
+        for (rn=loop_start; rn!=end; rn=NEXT_INSN (rn))
+          {
+              if ((GET_CODE (rn) == INSN || GET_CODE (rn) == JUMP_INSN
+	               || GET_CODE (rn) == CALL_INSN) && LOG_LINKS(rn))
+                {
+                    for (prev = 0, link = LOG_LINKS (rn); link;
+                         prev = link, link = XEXP (link, 1))
+                      {
+                          if (insns_deleted[INSN_UID(XEXP (link, 0))])
+	                    {
+	                      if (prev)
+	                        XEXP (prev, 1) = XEXP (link, 1);
+	                      else
+	                        LOG_LINKS (rn) = XEXP (link, 1);
+	                    }
+                      }
+
+                }
+          }
+    }
 }
 
 #if 0
@@ -2268,6 +2599,9 @@
       uid_loop_num[INSN_UID (insn)] = current_loop;
     }
 
+		    /* This loop will be continued with NEXT_INSN (insn).  */
+		    insn = PREV_INSN (insn);
+
   /* Any loop containing a label used in an initializer must be invalidated,
      because it can be jumped into from anywhere.  */
 
@@ -2281,6 +2615,17 @@
 	loop_invalid[loop_num] = 1;
     }
 
+
+#if HAVE_movstricthi
+  if (flag_sign_extension_elim)
+    {
+      int i;
+      for (i = max_loop_num-1; i >= 0; i--)
+        if (! loop_invalid[i] && loop_number_loop_ends[i])
+          sign_extension_reduction (loop_number_loop_starts[i],
+                                    loop_number_loop_ends [i]);
+    }
+#endif
   /* Now scan all insn's in the function.  If any JUMP_INSN branches into a
      loop that it is not contained within, that loop is marked invalid.
      If any INSN or CALL_INSN uses a label's address, then the loop containing
@@ -2294,11 +2639,12 @@
      label in our loop and will simplify processing by both us and a
      possible second cse pass.  */
 
+
   for (insn = f; insn; insn = NEXT_INSN (insn))
     if (GET_RTX_CLASS (GET_CODE (insn)) == 'i')
       {
 	int this_loop_num = uid_loop_num[INSN_UID (insn)];
-
+        
 	if (GET_CODE (insn) == INSN || GET_CODE (insn) == CALL_INSN)
 	  {
 	    rtx note = find_reg_note (insn, REG_LABEL, NULL_RTX);
@@ -2339,6 +2685,32 @@
 		 p = PREV_INSN (p))
 	      ;
 
+	      /* intel1 */
+            if (flag_opt_jumps_out)
+              {
+                /* Retarget a jump around a sequence that contains jumps out 
+                   of loop to jump out of the loop rather than jump around.  */
+                while (!(GET_CODE (p) == JUMP_INSN
+		        && JUMP_LABEL (p) != 0
+		        && condjump_p (p)
+		        && ! simplejump_p (p)
+		        && next_real_insn (JUMP_LABEL (p)) == our_next
+		       ) &&
+		      !(GET_CODE (p) == JUMP_INSN 
+		        && (JUMP_LABEL (p) == 0 
+		         || (uid_loop_num[INSN_UID (JUMP_LABEL (p))]
+			    == this_loop_num))
+		       ) 
+		      && GET_CODE (p) != CODE_LABEL 
+		      && !(GET_CODE (p) == NOTE
+		           && NOTE_LINE_NUMBER (p) == NOTE_INSN_LOOP_BEG) 
+		      && !(GET_CODE (p) == NOTE
+		           && NOTE_LINE_NUMBER (p) == NOTE_INSN_LOOP_END)
+		     )
+                  {
+                    p = PREV_INSN (p);
+                  }
+              }
 	    /* If we stopped on a JUMP_INSN to the next insn after INSN,
 	       we have a block of code to try to move.
 
@@ -2373,7 +2745,15 @@
 			&& uid_loop_num[INSN_UID (loc)] == target_loop_num)
 		      break;
 
-		if (loc)
+		if (loc 
+		     ||
+		    /* intel1 Enable the optimization even if no barier
+		              is found.  This requires adding a jump
+		              around the section of code moved out - but
+		              this can win if jumps NOT taken are preferred.  
+		    */
+		    (flag_opt_jumps_out 
+		         && LABEL_NUSES (JUMP_LABEL (p)) == 1))
 		  {
 		    rtx cond_label = JUMP_LABEL (p);
 		    rtx new_label = get_label_after (p);
@@ -2390,7 +2770,12 @@
 		       /* Include the BARRIER after INSN and copy the
 			  block after LOC.  */
 		       new_label = squeeze_notes (new_label, NEXT_INSN (insn));
-		       reorder_insns (new_label, NEXT_INSN (insn), loc);
+		       /* intel1 */
+		       if (loc)
+		         reorder_insns (new_label, NEXT_INSN (insn), loc);
+		       else
+		         reorder_insns (new_label, NEXT_INSN (insn), 
+		                      PREV_INSN (target));
 
 		       /* All those insns are now in TARGET_LOOP_NUM.  */
 		       for (q = new_label; q != NEXT_INSN (NEXT_INSN (insn));
@@ -2427,14 +2812,24 @@
 			  in loop_number_exit_labels, and marked as such.
 			  The easiest way to do this is to just call
 			  mark_loop_jump again for P.  */
+        
 		       mark_loop_jump (PATTERN (p), this_loop_num);
-
-		       /* If INSN now jumps to the insn after it,
-			  delete INSN.  */
-		       if (JUMP_LABEL (insn) != 0
-			   && (next_real_insn (JUMP_LABEL (insn))
-			       == next_real_insn (insn)))
-			 delete_insn (insn);
+                       /* intel1 */
+                       if (loc)
+                         {
+		           /* If INSN now jumps to the insn after it,
+			      delete INSN.  */
+		           if (JUMP_LABEL (insn) != 0
+			       && (next_real_insn (JUMP_LABEL (insn))
+			           == next_real_insn (insn)))
+			     delete_insn (insn);
+			 }
+		       else
+		         {
+		           /* move the jump insn to just before the new_label */
+		           reorder_insns (insn, NEXT_INSN (insn),
+		                          PREV_INSN (new_label));
+		         }
 		     }
 
 		    /* Continue the loop after where the conditional
@@ -2443,11 +2838,16 @@
 		       branch and hence needs no processing.  */
 		    insn = NEXT_INSN (cond_label);
 
-		    if (--LABEL_NUSES (cond_label) == 0)
-		      delete_insn (cond_label);
-
-		    /* This loop will be continued with NEXT_INSN (insn).  */
-		    insn = PREV_INSN (insn);
+                       /* intel1 */
+                    if (loc)
+                      {
+		        if (--LABEL_NUSES (cond_label) == 0)
+		          delete_insn (cond_label);
+		       }
+		     else
+		       {
+		          delete_insn (cond_label);
+		       }
 		  }
 	      }
 	  }
@@ -2535,7 +2935,16 @@
 		     "\nLoop at %d ignored due to multiple entry points.\n",
 		     INSN_UID (loop_number_loop_starts[dest_loop]));
 	  
+	  /* intel1
+	     If doing loop_spl we don't care if there are multiple jumps
+	     to the loop entry label.  */
+	  if (!doing_spl 
+	      || NEXT_INSN (loop_number_loop_starts[dest_loop]) 
+	           != XEXP (x, 0))
+	  {
+	    
 	  loop_invalid[dest_loop] = 1;
+	  }
 	}
       return;
 
@@ -2755,7 +3164,6 @@
   return 1 + conditional;
 }
 
-
 /* Return nonzero if all the insns in the loop that set REG
    are INSN and the immediately following insns,
    and if each of those insns sets REG in an invariant way
@@ -2984,6 +3392,22 @@
 		    may_not_move[regno] = 1;
 		  if (n_times_set[regno] < 127)
 		    ++n_times_set[regno];
+		  /* intel1 */
+		  if (doing_loop_after_global 
+		     && HARD_REGNO_NREGS (regno, GET_MODE (dest)) > 1)
+		    { /* Count each hard reg in the group.  */
+		        register int i,next_regno;
+
+		        i = HARD_REGNO_NREGS (regno, GET_MODE (dest));
+		        next_regno = regno + 1;
+		        while (i!=1)
+		          {
+		              if (n_times_set[next_regno] < 127)
+		                ++n_times_set[next_regno];
+		              next_regno++;
+		              i--;
+		          }
+		    }
 		  last_set[regno] = insn;
 		}
 	    }
@@ -3181,6 +3605,9 @@
   int call_seen;
   rtx test;
   rtx end_insert_before;
+  int try_compare_elimination, done_compare_elimination; /* intel1 */
+  rtx compare_insn, jump_insn, tinsn; /* intel1 */
+  int *times_reg_used; /* intel1 */
   int loop_depth = 0;
 
   reg_iv_type = (enum iv_mode *) alloca (max_reg_before_loop
@@ -3310,7 +3737,10 @@
 	     will be executed if the loop is executed.  */
 	  && ! (GET_CODE (p) == JUMP_INSN && JUMP_LABEL (p) == loop_top
 		&& ((NEXT_INSN (NEXT_INSN (p)) == loop_end && simplejump_p (p))
-		    || (NEXT_INSN (p) == loop_end && condjump_p (p)))))
+          || (NEXT_INSN (p) == loop_end && condjump_p (p))))
+     /*intel1*/  && !(GET_CODE (p) == JUMP_INSN
+                      && jumps_back_in_loop(p,loop_start,0,0))
+    )
 	not_every_iteration = 1;
 
       else if (GET_CODE (p) == NOTE)
@@ -3424,6 +3854,18 @@
 	}
     }
 
+  /* Now see if it is wothwhile to do compare elimination, remember it only
+     saves one instruction.  intel1
+  */
+  try_compare_elimination = 0;
+  if (flag_compare_elim 
+     && loop_number_exit_labels[uid_loop_num[INSN_UID (loop_start)]] == NULL)
+  {
+    possible_compare_elimination(loop_start, loop_end, &compare_insn, 
+                                 &jump_insn, &try_compare_elimination);
+    done_compare_elimination = 0;
+  }
+
   /* Look at the each biv and see if we can say anything better about its
      initial value from any initializing insns set up above.  (This is done
      in two passes to avoid missing SETs in a PARALLEL.)  */
@@ -3445,6 +3887,21 @@
 	   || GET_MODE (src) == VOIDmode)
 	  && valid_initial_value_p (src, bl->init_insn, call_seen, loop_start))
 	{
+	  /* intel1 */
+	  if (flag_compare_elim && !flag_unroll_loops 
+	     && try_compare_elimination && !done_compare_elimination 
+	     && bl->biv_count == 1 
+	     && bl->biv->mult_val == const1_rtx 
+	     && REGNO (XEXP (SET_SRC (PATTERN (compare_insn)), 0)) == bl->regno 
+	     &&  (done_compare_elimination 
+	     = compare_elimination (bl, loop_start, loop_end, 
+	                         compare_insn, jump_insn,0)))
+	    {
+    	      rtx tem = find_reg_note (bl->init_insn, REG_EQUAL, 0);
+	      if (tem)
+		XEXP (tem, 0) = SET_SRC (bl->init_set);
+	      src = SET_SRC (bl->init_set);
+	    }
 	  bl->initial_value = src;
 
 	  if (loop_dump_stream)
@@ -3588,7 +4045,10 @@
 	     will be executed if the loop is executed.  */
 	  && ! (GET_CODE (p) == JUMP_INSN && JUMP_LABEL (p) == loop_top
 		&& ((NEXT_INSN (NEXT_INSN (p)) == loop_end && simplejump_p (p))
-		    || (NEXT_INSN (p) == loop_end && condjump_p (p)))))
+          || (NEXT_INSN (p) == loop_end && condjump_p (p))))
+     /*intel1*/ && !(GET_CODE (p) == JUMP_INSN
+                     && jumps_back_in_loop(p,loop_start,0,0))
+    )
 	not_every_iteration = 1;
 
       else if (GET_CODE (p) == NOTE)
@@ -3654,6 +4114,12 @@
   for (bl = loop_iv_list; bl; bl = bl->next)
     {
       struct induction *v;
+      /* intel1 */
+#ifdef SAVE_ON_REGS
+      int num_add_vals_live_outside =0;
+      int no_mem_givs = 0;
+      int contains_loop =0;
+#endif
       int benefit;
       int all_reduced;
       rtx final_value = 0;
@@ -3711,6 +4177,97 @@
 	 We can't (currently) eliminate the biv unless this is so.  */
       all_reduced = 1;
 
+      /* intel1 */
+#ifdef SAVE_ON_REGS
+      /* Only reduce DEST_ADDR givs of this biv if they will not increase
+         register pressure.  
+      */
+      if (!flag_all_mem_givs && flag_opt_reg_use)
+        {
+          int num_mult_val_saved = 0;
+          int num_givs_to_update = 0;
+          num_add_vals_live_outside = 0;
+          no_mem_givs = 0;
+          contains_loop = loop_contains_loop (loop_start, end);
+        
+          for (v = bl->giv; v; v = v->next_iv)
+            {
+              if (v->giv_type == DEST_ADDR)
+                num_mult_val_saved++;
+              if (v->giv_type == DEST_ADDR && !v->same)
+                {
+                  num_givs_to_update++;
+                  if (v->add_val && GET_CODE (v->add_val) == REG 
+                     && REGNO (v->add_val) >= FIRST_PSEUDO_REGISTER 
+                     && (contains_loop 
+                         || REGNO (v->add_val)<max_reg_before_loop))
+                    {
+                      if (loop_dump_stream 
+                         && reg_live_outside_loop[REGNO (v->add_val)])
+                        {
+                          fprintf (loop_dump_stream, 
+                          "dest addr giv at %d has add_val live outside reg%d\n", 
+                          INSN_UID (v->insn), REGNO (v->add_val));
+                        }
+                      if (contains_loop)
+                        num_add_vals_live_outside += 2;
+                      else
+                        {
+                          num_add_vals_live_outside += 
+                            reg_live_outside_loop[REGNO (v->add_val)];
+                        }
+                    }
+                  else if (v->add_val && GET_CODE (v->add_val) == CONST_INT 
+                           && v->mult_val == const1_rtx)
+                    { /* Disable this reduction. */
+                      num_add_vals_live_outside = (1 << ((sizeof (int)*8)-4));
+                    }
+                }
+            }
+#ifdef MAX_DEST_ADDR_GIVS
+        if (num_givs_to_update > MAX_DEST_ADDR_GIVS)
+          {
+            no_mem_givs = 1;
+          }
+#endif
+        /* Heuristic here:
+           a) If the biv is eliminated that saves one register in the loop.  
+           b) Each giv_to_update must be updated at the end of the loop.  
+           c) Each add_val_live_outside may cause a spill somewhere.  
+        */
+        if (loop_dump_stream)
+          {
+            fprintf (loop_dump_stream,
+            "eliminable %d num_updates %d mults_saved %d adds_outside %d heu %d\n",
+            bl->eliminable, num_givs_to_update, num_mult_val_saved,
+            num_add_vals_live_outside,
+            (((int)(bl->eliminable) * -3) 
+             + (num_givs_to_update+((int)(bl->eliminable) * -1)) 
+             + (num_mult_val_saved*-1) +
+             + (num_add_vals_live_outside*3) 
+            ));
+          }
+        if (no_mem_givs 
+            ||  
+            (((int)(bl->eliminable) * -3) 
+             + (num_givs_to_update+((int)(bl->eliminable) * -1)) 
+             + (num_mult_val_saved*-1) +
+             + (num_add_vals_live_outside*3) > 0
+            )
+           )
+          {
+            all_reduced = 0;
+            for (v = bl->giv; v; v = v->next_iv)
+              {
+                if (v->giv_type == DEST_ADDR)
+                  {
+                    v->ignore = 1;
+                  }
+              }
+          }
+      }
+#endif /* SAVE_ON_REGS */
+
       /* Check each giv in this class to see if we will benefit by reducing
 	 it.  Skip giv's combined with others.  */
       for (v = bl->giv; v; v = v->next_iv)
